<html>
<head>
<title>Ogre::RTShader::HLSLProgramProcessor Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html">HLSLProgramProcessor</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-static-methods">Static Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::HLSLProgramProcessor Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::HLSLProgramProcessor" --><!-- doxytag: inherits="Ogre::RTShader::ProgramProcessor" -->
<p>CG Language program processor class.  
 <a href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderHLSLProgramProcessor_8h_source.html">OgreShaderHLSLProgramProcessor.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::HLSLProgramProcessor:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1HLSLProgramProcessor__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1HLSLProgramProcessor_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1HLSLProgramProcessor_inherit__map" id="Ogre_1_1RTShader_1_1HLSLProgramProcessor_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1RTShader_1_1ProgramProcessor.html" title="A class that provides extra processing services on CPU based programs." alt="" coords="23,83,255,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="61,5,216,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1HLSLProgramProcessor-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#a5e3d3412bd3b0ca65d0180878b889f87">HLSLProgramProcessor</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="#a5e3d3412bd3b0ca65d0180878b889f87"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#ac496b56d23e97b08eab3c8849bfe2241">~HLSLProgramProcessor</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#ac496b56d23e97b08eab3c8849bfe2241"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#ae10a2fcb09e8cedc6ee9fe28e5279814">getTargetLanguage</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the target language of this processor.  <a href="#ae10a2fcb09e8cedc6ee9fe28e5279814"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#a6ac2d5788fe9a8b0414126b4ddddc27f">preCreateGpuPrograms</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *programSet)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#a98e212159432f6e6488e64ad0d70e07d">postCreateGpuPrograms</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *programSet)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#aa293c015d9e2ebb53f4d5b7a115c672f">TargetLanguage</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html">MergeParameter</a> &gt;<br class="typebreak"/>
::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a><br class="typebreak"/>
&lt; <a class="el" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html">MergeCombination</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a3c0d805a8cdf9a02b95bcfeb80dc331c">MergeCombinationList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a03d0a099a4a495164fe4603d814d18b9">OperandPtrVector</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="classOgre_1_1RTShader_1_1Parameter.html">Parameter</a> <br class="typebreak"/>
*, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a03d0a099a4a495164fe4603d814d18b9">OperandPtrVector</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt; <a class="el" href="classOgre_1_1RTShader_1_1Parameter.html">Parameter</a> <br class="typebreak"/>
*, <a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a13f1ecf882f00aa063cd389f5dde8b6f">buildMergeCombinations</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Build parameter merging combinations.  <a href="#a13f1ecf882f00aa063cd389f5dde8b6f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ab5da5dd15276e845bb154d37da2609b6">compactVsOutputs</a> (<a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *vsMain, <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *fsMain)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Compact the vertex shader output registers.  <a href="#ab5da5dd15276e845bb154d37da2609b6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a28006c7e9a600fe675ff4d1b7e23b9b0">countVsTexcoordOutputs</a> (<a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *vsMain, int &amp;outTexCoordSlots, int &amp;outTexCoordFloats)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method that counts vertex shader texcoord output slots and output floats.  <a href="#a28006c7e9a600fe675ff4d1b7e23b9b0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a77c7a05cc0e82b5206207926f8a236de">buildTexcoordTable</a> (const <a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> &amp;paramList, <a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> outParamsTable[4])</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal function that builds parameters table.  <a href="#a77c7a05cc0e82b5206207926f8a236de"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8b5b5b24fce13f87944b3604147b3f8b">mergeParameters</a> (<a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> paramsTable[4], <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;mergedParams, <a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> &amp;splitParams)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Merge the parameters from the given table.  <a href="#a8b5b5b24fce13f87944b3604147b3f8b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ad869da13ecb3be55b41af83d302be547">mergeParametersByPredefinedCombinations</a> (<a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> paramsTable[4], <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;mergedParams)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal function that creates merged parameter using pre defined combinations.  <a href="#ad869da13ecb3be55b41af83d302be547"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ac8db78a9768e4d66c7557302bef26b75">mergeParametersByCombination</a> (const <a class="el" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html">MergeCombination</a> &amp;combination, <a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> paramsTable[4], <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html">MergeParameter</a> *mergedParameter)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal function that creates merged parameter from given combination.  <a href="#ac8db78a9768e4d66c7557302bef26b75"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a287bde31d129b95ea112002019701ba5">mergeParametersReminders</a> (<a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> paramsTable[4], <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;mergedParams, <a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> &amp;splitParams)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Merge reminders parameters that could not be merged into one slot using the predefined combinations.  <a href="#a287bde31d129b95ea112002019701ba5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ab804286b7ceec3520888687a43f57b05">generateLocalSplitParameters</a> (<a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *func, <a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a> progType, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;mergedParams, <a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> &amp;splitParams, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a> &amp;localParamsMap)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Generates local parameters for the split parameters and perform packing/unpacking operation using them.  <a href="#ab804286b7ceec3520888687a43f57b05"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a1ccfd04b91d75f3c2d4052ad9446a9f5">rebuildParameterList</a> (<a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *func, int paramsUsage, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;mergedParams)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Rebuild the given parameters list using the merged parameters.  <a href="#a1ccfd04b91d75f3c2d4052ad9446a9f5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a2709aaaeacbdfff92a185ea00351a82f">rebuildFunctionInvocations</a> (<a class="el" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a> &amp;funcAtomList, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;mergedParams, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a> &amp;localParamsMap)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Rebuild function invocations by replacing references to old source parameters with the matching merged parameters components.  <a href="#a2709aaaeacbdfff92a185ea00351a82f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a2cfe65cba64966e9c8b9b2bc6019de23">buildParameterReferenceMap</a> (<a class="el" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a> &amp;funcAtomList, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a> &amp;paramsRefMap)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Builds a map between parameter and all the references to it.  <a href="#a2cfe65cba64966e9c8b9b2bc6019de23"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ab2280321a2bdfcc53b7c90c7b0f30e9e">replaceParametersReferences</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;mergedParams, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a> &amp;paramsRefMap)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Replace references to old parameters with the new merged parameters.  <a href="#ab2280321a2bdfcc53b7c90c7b0f30e9e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#af05beb732b744cacd0d22644a8875bb7">replaceSplitParametersReferences</a> (<a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a> &amp;localParamsMap, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a> &amp;paramsRefMap)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Replace references to old parameters that have been split with the new local parameters that represents them.  <a href="#af05beb732b744cacd0d22644a8875bb7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a4719f868d8fe3993a7f3f816276c5af2">bindAutoParameters</a> (<a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *pCpuProgram, <a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a> pGpuProgram)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Bind the auto parameters for a given CPU and GPU program set.  <a href="#a4719f868d8fe3993a7f3f816276c5af2"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-static-methods"></a>
Static Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a56c5d6f12f0eef27574321db939767ee">getParameterFloatCount</a> (<a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a> type)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return number of floats needed by the given type.  <a href="#a56c5d6f12f0eef27574321db939767ee"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aff0d37e4144948c20edeb4b9e2b2e1e5">getParameterMaskByType</a> (<a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a> type)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the parameter mask of by the given parameter type (I.E: X|Y for FLOAT2 etc..)  <a href="#aff0d37e4144948c20edeb4b9e2b2e1e5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a7d4cc1775674d3fa947bee1b978d9f61">getParameterMaskByFloatCount</a> (int floatCount)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the parameter mask of by the float count type (I.E: X|Y for 2 etc..)  <a href="#a7d4cc1775674d3fa947bee1b978d9f61"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a3c0d805a8cdf9a02b95bcfeb80dc331c">MergeCombinationList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a060e0a7726b01ff4bc1c83fc064ba406">mParamMergeCombinations</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#af100cb3dc3fdd00a44e85922df61863c">mMaxTexCoordSlots</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ada7e3fd71cc0ce8aee28b5fe0b90d13e">mMaxTexCoordFloats</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">std::map&lt; <a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ad88eb5eeb95f7cbe526b124e793fd6ae">mFunctionMap</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>CG Language program processor class. </p>

<p>Definition at line <a class="el" href="OgreShaderHLSLProgramProcessor_8h_source.html#l00046">46</a> of file <a class="el" href="OgreShaderHLSLProgramProcessor_8h_source.html">OgreShaderHLSLProgramProcessor.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="aed0a909440b35a25ed3f29349f59a5b2"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::LocalParameterMap" ref="aed0a909440b35a25ed3f29349f59a5b2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="classOgre_1_1RTShader_1_1Parameter.html">Parameter</a>*, <a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">Ogre::RTShader::ProgramProcessor::LocalParameterMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramProcessor_8h_source.html#l00162">162</a> of file <a class="el" href="OgreShaderProgramProcessor_8h_source.html">OgreShaderProgramProcessor.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3c0d805a8cdf9a02b95bcfeb80dc331c"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::MergeCombinationList" ref="a3c0d805a8cdf9a02b95bcfeb80dc331c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html">MergeCombination</a>&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a3c0d805a8cdf9a02b95bcfeb80dc331c">Ogre::RTShader::ProgramProcessor::MergeCombinationList</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramProcessor_8h_source.html#l00157">157</a> of file <a class="el" href="OgreShaderProgramProcessor_8h_source.html">OgreShaderProgramProcessor.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9079cdbbb382cabac306faa9d407e4b9"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::MergeParameterList" ref="a9079cdbbb382cabac306faa9d407e4b9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html">MergeParameter</a>&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">Ogre::RTShader::ProgramProcessor::MergeParameterList</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramProcessor_8h_source.html#l00130">130</a> of file <a class="el" href="OgreShaderProgramProcessor_8h_source.html">OgreShaderProgramProcessor.h</a>.</p>

</div>
</div>
<a class="anchor" id="a03d0a099a4a495164fe4603d814d18b9"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::OperandPtrVector" ref="a03d0a099a4a495164fe4603d814d18b9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a>*&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a03d0a099a4a495164fe4603d814d18b9">Ogre::RTShader::ProgramProcessor::OperandPtrVector</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramProcessor_8h_source.html#l00160">160</a> of file <a class="el" href="OgreShaderProgramProcessor_8h_source.html">OgreShaderProgramProcessor.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8106d085867928cfe50d3b5a6e6b6ed7"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::ParameterOperandMap" ref="a8106d085867928cfe50d3b5a6e6b6ed7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1map.html">map</a>&lt;<a class="el" href="classOgre_1_1RTShader_1_1Parameter.html">Parameter</a>*, <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a03d0a099a4a495164fe4603d814d18b9">OperandPtrVector</a>&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">Ogre::RTShader::ProgramProcessor::ParameterOperandMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramProcessor_8h_source.html#l00161">161</a> of file <a class="el" href="OgreShaderProgramProcessor_8h_source.html">OgreShaderProgramProcessor.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a5e3d3412bd3b0ca65d0180878b889f87"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::HLSLProgramProcessor" ref="a5e3d3412bd3b0ca65d0180878b889f87" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#a5e3d3412bd3b0ca65d0180878b889f87">Ogre::RTShader::HLSLProgramProcessor::HLSLProgramProcessor</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class constructor. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">type</td><td>The type of this program. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ac496b56d23e97b08eab3c8849bfe2241"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::~HLSLProgramProcessor" ref="ac496b56d23e97b08eab3c8849bfe2241" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#ac496b56d23e97b08eab3c8849bfe2241">Ogre::RTShader::HLSLProgramProcessor::~HLSLProgramProcessor</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a4719f868d8fe3993a7f3f816276c5af2"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::bindAutoParameters" ref="a4719f868d8fe3993a7f3f816276c5af2" args="(Program *pCpuProgram, GpuProgramPtr pGpuProgram)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a4719f868d8fe3993a7f3f816276c5af2">Ogre::RTShader::ProgramProcessor::bindAutoParameters</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Program.html">Program</a> *&#160;</td>
          <td class="paramname"><em>pCpuProgram</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramPtr.html">GpuProgramPtr</a>&#160;</td>
          <td class="paramname"><em>pGpuProgram</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Bind the auto parameters for a given CPU and GPU program set. </p>

</div>
</div>
<a class="anchor" id="a13f1ecf882f00aa063cd389f5dde8b6f"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::buildMergeCombinations" ref="a13f1ecf882f00aa063cd389f5dde8b6f" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a13f1ecf882f00aa063cd389f5dde8b6f">Ogre::RTShader::ProgramProcessor::buildMergeCombinations</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Build parameter merging combinations. </p>

</div>
</div>
<a class="anchor" id="a2cfe65cba64966e9c8b9b2bc6019de23"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::buildParameterReferenceMap" ref="a2cfe65cba64966e9c8b9b2bc6019de23" args="(FunctionAtomInstanceList &amp;funcAtomList, ParameterOperandMap &amp;paramsRefMap)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a2cfe65cba64966e9c8b9b2bc6019de23">Ogre::RTShader::ProgramProcessor::buildParameterReferenceMap</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a> &amp;&#160;</td>
          <td class="paramname"><em>funcAtomList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a> &amp;&#160;</td>
          <td class="paramname"><em>paramsRefMap</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Builds a map between parameter and all the references to it. </p>

</div>
</div>
<a class="anchor" id="a77c7a05cc0e82b5206207926f8a236de"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::buildTexcoordTable" ref="a77c7a05cc0e82b5206207926f8a236de" args="(const ShaderParameterList &amp;paramList, ShaderParameterList outParamsTable[4])" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a77c7a05cc0e82b5206207926f8a236de">Ogre::RTShader::ProgramProcessor::buildTexcoordTable</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>paramList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&#160;</td>
          <td class="paramname"><em>outParamsTable</em>[4]&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal function that builds parameters table. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">paramList</td><td>The parameter list. </td></tr>
    <tr><td class="paramname">outParamsTable</td><td>Will hold the texcoord params sorted by types in each row. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab5da5dd15276e845bb154d37da2609b6"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::compactVsOutputs" ref="ab5da5dd15276e845bb154d37da2609b6" args="(Function *vsMain, Function *fsMain)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ab5da5dd15276e845bb154d37da2609b6">Ogre::RTShader::ProgramProcessor::compactVsOutputs</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>vsMain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>fsMain</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Compact the vertex shader output registers. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">vsMain</td><td>The vertex shader entry function. </td></tr>
    <tr><td class="paramname">fsMain</td><td>The fragment shader entry function. Return true on success. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a28006c7e9a600fe675ff4d1b7e23b9b0"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::countVsTexcoordOutputs" ref="a28006c7e9a600fe675ff4d1b7e23b9b0" args="(Function *vsMain, int &amp;outTexCoordSlots, int &amp;outTexCoordFloats)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a28006c7e9a600fe675ff4d1b7e23b9b0">Ogre::RTShader::ProgramProcessor::countVsTexcoordOutputs</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>vsMain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>outTexCoordSlots</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int &amp;&#160;</td>
          <td class="paramname"><em>outTexCoordFloats</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method that counts vertex shader texcoord output slots and output floats. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">vsMain</td><td>The vertex shader entry function. </td></tr>
    <tr><td class="paramname">outTexCoordSlots</td><td>Will hold the number of used output texcoord slots. </td></tr>
    <tr><td class="paramname">outTexCoordFloats</td><td>Will hold the total number of floats used by output texcoord slots. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab804286b7ceec3520888687a43f57b05"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::generateLocalSplitParameters" ref="ab804286b7ceec3520888687a43f57b05" args="(Function *func, GpuProgramType progType, MergeParameterList &amp;mergedParams, ShaderParameterList &amp;splitParams, LocalParameterMap &amp;localParamsMap)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ab804286b7ceec3520888687a43f57b05">Ogre::RTShader::ProgramProcessor::generateLocalSplitParameters</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e">GpuProgramType</a>&#160;</td>
          <td class="paramname"><em>progType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>mergedParams</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>splitParams</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a> &amp;&#160;</td>
          <td class="paramname"><em>localParamsMap</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generates local parameters for the split parameters and perform packing/unpacking operation using them. </p>

</div>
</div>
<a class="anchor" id="a56c5d6f12f0eef27574321db939767ee"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::getParameterFloatCount" ref="a56c5d6f12f0eef27574321db939767ee" args="(GpuConstantType type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static int <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a56c5d6f12f0eef27574321db939767ee">Ogre::RTShader::ProgramProcessor::getParameterFloatCount</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>&#160;</td>
          <td class="paramname"><em>type</em></td><td>)</td>
          <td><code> [static, protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return number of floats needed by the given type. </p>

</div>
</div>
<a class="anchor" id="a7d4cc1775674d3fa947bee1b978d9f61"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::getParameterMaskByFloatCount" ref="a7d4cc1775674d3fa947bee1b978d9f61" args="(int floatCount)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static int <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a7d4cc1775674d3fa947bee1b978d9f61">Ogre::RTShader::ProgramProcessor::getParameterMaskByFloatCount</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>floatCount</em></td><td>)</td>
          <td><code> [static, protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the parameter mask of by the float count type (I.E: X|Y for 2 etc..) </p>

</div>
</div>
<a class="anchor" id="aff0d37e4144948c20edeb4b9e2b2e1e5"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::getParameterMaskByType" ref="aff0d37e4144948c20edeb4b9e2b2e1e5" args="(GpuConstantType type)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static int <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aff0d37e4144948c20edeb4b9e2b2e1e5">Ogre::RTShader::ProgramProcessor::getParameterMaskByType</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>&#160;</td>
          <td class="paramname"><em>type</em></td><td>)</td>
          <td><code> [static, protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the parameter mask of by the given parameter type (I.E: X|Y for FLOAT2 etc..) </p>

</div>
</div>
<a class="anchor" id="ae10a2fcb09e8cedc6ee9fe28e5279814"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::getTargetLanguage" ref="ae10a2fcb09e8cedc6ee9fe28e5279814" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#ae10a2fcb09e8cedc6ee9fe28e5279814">Ogre::RTShader::HLSLProgramProcessor::getTargetLanguage</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the target language of this processor. </p>

<p>Implements <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ae0789fecd0ee5b56dc6b69d093a27d75">Ogre::RTShader::ProgramProcessor</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderHLSLProgramProcessor_8h_source.html#l00061">61</a> of file <a class="el" href="OgreShaderHLSLProgramProcessor_8h_source.html">OgreShaderHLSLProgramProcessor.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8b5b5b24fce13f87944b3604147b3f8b"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::mergeParameters" ref="a8b5b5b24fce13f87944b3604147b3f8b" args="(ShaderParameterList paramsTable[4], MergeParameterList &amp;mergedParams, ShaderParameterList &amp;splitParams)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8b5b5b24fce13f87944b3604147b3f8b">Ogre::RTShader::ProgramProcessor::mergeParameters</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&#160;</td>
          <td class="paramname"><em>paramsTable</em>[4], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>mergedParams</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>splitParams</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Merge the parameters from the given table. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">paramsTable</td><td>Source parameters table. </td></tr>
    <tr><td class="paramname">mergedParams</td><td>Will hold the merged parameters list. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ac8db78a9768e4d66c7557302bef26b75"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::mergeParametersByCombination" ref="ac8db78a9768e4d66c7557302bef26b75" args="(const MergeCombination &amp;combination, ShaderParameterList paramsTable[4], MergeParameter *mergedParameter)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ac8db78a9768e4d66c7557302bef26b75">Ogre::RTShader::ProgramProcessor::mergeParametersByCombination</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeCombination.html">MergeCombination</a> &amp;&#160;</td>
          <td class="paramname"><em>combination</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&#160;</td>
          <td class="paramname"><em>paramsTable</em>[4], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor_1_1MergeParameter.html">MergeParameter</a> *&#160;</td>
          <td class="paramname"><em>mergedParameter</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal function that creates merged parameter from given combination. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">combination</td><td>The merge combination to try. </td></tr>
    <tr><td class="paramname">paramsTable</td><td>The params table sorted by types in each row. </td></tr>
    <tr><td class="paramname">mergedParameter</td><td>Will hold the merged parameter. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ad869da13ecb3be55b41af83d302be547"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::mergeParametersByPredefinedCombinations" ref="ad869da13ecb3be55b41af83d302be547" args="(ShaderParameterList paramsTable[4], MergeParameterList &amp;mergedParams)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ad869da13ecb3be55b41af83d302be547">Ogre::RTShader::ProgramProcessor::mergeParametersByPredefinedCombinations</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&#160;</td>
          <td class="paramname"><em>paramsTable</em>[4], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>mergedParams</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal function that creates merged parameter using pre defined combinations. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">paramsTable</td><td>Source parameters table. </td></tr>
    <tr><td class="paramname">mergedParams</td><td>The merged parameters list. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a287bde31d129b95ea112002019701ba5"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::mergeParametersReminders" ref="a287bde31d129b95ea112002019701ba5" args="(ShaderParameterList paramsTable[4], MergeParameterList &amp;mergedParams, ShaderParameterList &amp;splitParams)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a287bde31d129b95ea112002019701ba5">Ogre::RTShader::ProgramProcessor::mergeParametersReminders</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a>&#160;</td>
          <td class="paramname"><em>paramsTable</em>[4], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>mergedParams</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga722d7eb730c66ec0262df86ebf9888b1">ShaderParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>splitParams</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Merge reminders parameters that could not be merged into one slot using the predefined combinations. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">paramsTable</td><td>The params table sorted by types in each row. </td></tr>
    <tr><td class="paramname">mergedParams</td><td>The merged parameters list. </td></tr>
    <tr><td class="paramname">splitParams</td><td>The split parameters list. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a98e212159432f6e6488e64ad0d70e07d"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::postCreateGpuPrograms" ref="a98e212159432f6e6488e64ad0d70e07d" args="(ProgramSet *programSet)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#a98e212159432f6e6488e64ad0d70e07d">Ogre::RTShader::HLSLProgramProcessor::postCreateGpuPrograms</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td>
          <td class="paramname"><em>programSet</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a6ab57778e1f0b801b6595dc1e0c3aa91" title="Called after creation of the GPU programs.">ProgramProcessor::postCreateGpuPrograms</a> </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a6ab57778e1f0b801b6595dc1e0c3aa91">Ogre::RTShader::ProgramProcessor</a>.</p>

</div>
</div>
<a class="anchor" id="a6ac2d5788fe9a8b0414126b4ddddc27f"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::preCreateGpuPrograms" ref="a6ac2d5788fe9a8b0414126b4ddddc27f" args="(ProgramSet *programSet)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#a6ac2d5788fe9a8b0414126b4ddddc27f">Ogre::RTShader::HLSLProgramProcessor::preCreateGpuPrograms</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramSet.html">ProgramSet</a> *&#160;</td>
          <td class="paramname"><em>programSet</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#af36a591589a387d9ab85a7f4fe724fce" title="Called before creation of the GPU programs.">ProgramProcessor::preCreateGpuPrograms</a> </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#af36a591589a387d9ab85a7f4fe724fce">Ogre::RTShader::ProgramProcessor</a>.</p>

</div>
</div>
<a class="anchor" id="a2709aaaeacbdfff92a185ea00351a82f"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::rebuildFunctionInvocations" ref="a2709aaaeacbdfff92a185ea00351a82f" args="(FunctionAtomInstanceList &amp;funcAtomList, MergeParameterList &amp;mergedParams, LocalParameterMap &amp;localParamsMap)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a2709aaaeacbdfff92a185ea00351a82f">Ogre::RTShader::ProgramProcessor::rebuildFunctionInvocations</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga3dd6945ed92e7a6afc9274f40081a981">FunctionAtomInstanceList</a> &amp;&#160;</td>
          <td class="paramname"><em>funcAtomList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>mergedParams</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a> &amp;&#160;</td>
          <td class="paramname"><em>localParamsMap</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Rebuild function invocations by replacing references to old source parameters with the matching merged parameters components. </p>

</div>
</div>
<a class="anchor" id="a1ccfd04b91d75f3c2d4052ad9446a9f5"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::rebuildParameterList" ref="a1ccfd04b91d75f3c2d4052ad9446a9f5" args="(Function *func, int paramsUsage, MergeParameterList &amp;mergedParams)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a1ccfd04b91d75f3c2d4052ad9446a9f5">Ogre::RTShader::ProgramProcessor::rebuildParameterList</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *&#160;</td>
          <td class="paramname"><em>func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>paramsUsage</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>mergedParams</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Rebuild the given parameters list using the merged parameters. </p>

</div>
</div>
<a class="anchor" id="ab2280321a2bdfcc53b7c90c7b0f30e9e"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::replaceParametersReferences" ref="ab2280321a2bdfcc53b7c90c7b0f30e9e" args="(MergeParameterList &amp;mergedParams, ParameterOperandMap &amp;paramsRefMap)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ab2280321a2bdfcc53b7c90c7b0f30e9e">Ogre::RTShader::ProgramProcessor::replaceParametersReferences</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a9079cdbbb382cabac306faa9d407e4b9">MergeParameterList</a> &amp;&#160;</td>
          <td class="paramname"><em>mergedParams</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a> &amp;&#160;</td>
          <td class="paramname"><em>paramsRefMap</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Replace references to old parameters with the new merged parameters. </p>

</div>
</div>
<a class="anchor" id="af05beb732b744cacd0d22644a8875bb7"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::replaceSplitParametersReferences" ref="af05beb732b744cacd0d22644a8875bb7" args="(LocalParameterMap &amp;localParamsMap, ParameterOperandMap &amp;paramsRefMap)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#af05beb732b744cacd0d22644a8875bb7">Ogre::RTShader::ProgramProcessor::replaceSplitParametersReferences</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#aed0a909440b35a25ed3f29349f59a5b2">LocalParameterMap</a> &amp;&#160;</td>
          <td class="paramname"><em>localParamsMap</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a8106d085867928cfe50d3b5a6e6b6ed7">ParameterOperandMap</a> &amp;&#160;</td>
          <td class="paramname"><em>paramsRefMap</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Replace references to old parameters that have been split with the new local parameters that represents them. </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="ad88eb5eeb95f7cbe526b124e793fd6ae"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::mFunctionMap" ref="ad88eb5eeb95f7cbe526b124e793fd6ae" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::map&lt;<a class="el" href="classOgre_1_1RTShader_1_1Function.html">Function</a> *, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> *&gt; <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ad88eb5eeb95f7cbe526b124e793fd6ae">Ogre::RTShader::ProgramProcessor::mFunctionMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramProcessor_8h_source.html#l00254">254</a> of file <a class="el" href="OgreShaderProgramProcessor_8h_source.html">OgreShaderProgramProcessor.h</a>.</p>

</div>
</div>
<a class="anchor" id="ada7e3fd71cc0ce8aee28b5fe0b90d13e"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::mMaxTexCoordFloats" ref="ada7e3fd71cc0ce8aee28b5fe0b90d13e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#ada7e3fd71cc0ce8aee28b5fe0b90d13e">Ogre::RTShader::ProgramProcessor::mMaxTexCoordFloats</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramProcessor_8h_source.html#l00253">253</a> of file <a class="el" href="OgreShaderProgramProcessor_8h_source.html">OgreShaderProgramProcessor.h</a>.</p>

</div>
</div>
<a class="anchor" id="af100cb3dc3fdd00a44e85922df61863c"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::mMaxTexCoordSlots" ref="af100cb3dc3fdd00a44e85922df61863c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#af100cb3dc3fdd00a44e85922df61863c">Ogre::RTShader::ProgramProcessor::mMaxTexCoordSlots</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramProcessor_8h_source.html#l00252">252</a> of file <a class="el" href="OgreShaderProgramProcessor_8h_source.html">OgreShaderProgramProcessor.h</a>.</p>

</div>
</div>
<a class="anchor" id="a060e0a7726b01ff4bc1c83fc064ba406"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::mParamMergeCombinations" ref="a060e0a7726b01ff4bc1c83fc064ba406" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a3c0d805a8cdf9a02b95bcfeb80dc331c">MergeCombinationList</a> <a class="el" href="classOgre_1_1RTShader_1_1ProgramProcessor.html#a060e0a7726b01ff4bc1c83fc064ba406">Ogre::RTShader::ProgramProcessor::mParamMergeCombinations</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderProgramProcessor_8h_source.html#l00251">251</a> of file <a class="el" href="OgreShaderProgramProcessor_8h_source.html">OgreShaderProgramProcessor.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa293c015d9e2ebb53f4d5b7a115c672f"></a><!-- doxytag: member="Ogre::RTShader::HLSLProgramProcessor::TargetLanguage" ref="aa293c015d9e2ebb53f4d5b7a115c672f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1HLSLProgramProcessor.html#aa293c015d9e2ebb53f4d5b7a115c672f">Ogre::RTShader::HLSLProgramProcessor::TargetLanguage</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderHLSLProgramProcessor_8h_source.html#l00072">72</a> of file <a class="el" href="OgreShaderHLSLProgramProcessor_8h_source.html">OgreShaderHLSLProgramProcessor.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderHLSLProgramProcessor_8h_source.html">OgreShaderHLSLProgramProcessor.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:32
</p>
</body>
</html>
